      subroutine caleiv(u,w,eiv,siv,visc
     $     ,dx,dz,dxs,dzs,dxi,dzi,dxsi,dzsi,jstas,jends)
      use para4common
***********************************************************************
*     calculate 2nd invariants of
*     strain rate/stress tensors
***********************************************************************
      implicit none
      include "meshnum"
c
      real*8 u(iax,jax),w(iax,jax),eiv(iax,jax)
     $     ,siv(iax,jax),visc(iax,jax)
      real*8 dxi(iax),dzi(jax),dxsi(iax),dzsi(jax)
      real*8 dx(iax),dz(jax),dxs(iax),dzs(jax)
      real*8 e11,e12,e22,dudz,dwdx
      integer i,j
      integer jstas(0:maxprocs-1),jends(0:maxprocs-1)
c
      call myshift(u,jstas,jends)
      call myshift(w,jstas,jends)
c
      do j = max(2,jstas(myrank)),min(jax-1,jends(myrank))
         do i = 2,iax-1
            e11 = (u(i+1,j)-u(i,j))*dxi(i)
            e22 = (w(i,j+1)-w(i,j))*dzi(j)
            dudz = .125d0*dzsi(j)*dzsi(j+1)*(
     $           2.d0*dzs(j)*(u(i,j+1)+u(i+1,j+1))
     $           +(dz(j+1)-dz(j-1))*(u(i,j)+u(i+1,j))
     $           -2.d0*dzs(j+1)*(u(i,j-1)+u(i+1,j-1)))
            dwdx = 0.125d0*dxsi(i)*dxsi(i+1)*(
     $           2.d0*dxs(i)*(w(i+1,j)+w(i+1,j+1))
     $           +(dx(i+1)-dx(i-1))*(w(i,j)+w(i,j+1))
     $           -2.d0*dxs(i+1)*(w(i-1,j)+w(i-1,j+1)))
            e12 = dudz+dwdx
            eiv(i,j) =
     $           dsqrt((e11*e11+e22*e22+2.d0*e12*e12)*0.5d0)
         enddo
      enddo
      do j = max(2,jstas(myrank)),min(jax-1,jends(myrank))
         do i = 2,iax-1
            siv(i,j) = visc(i,j)*eiv(i,j)
         enddo
      enddo
c
      return
      end
