      subroutine mconst(dx,dxs,dz,dzs,xp,xc,zp,zc
     $     ,dxi,dxsi,dzi,dzsi,areai
     $     ,cx1,cx2,cx3,cx4,cz1,cz2,cz3,cz4)
***********************************************************************
*     calculate mesh constants
***********************************************************************
      implicit none
      include "meshnum"
c
      integer i,j
      real*8 dx(iax),dxs(iax),dz(jax),dzs(jax)
      real*8 xp(iax),xc(iax),zp(jax),zc(jax)
      real*8 dxi(iax),dxsi(iax),dzi(jax),dzsi(jax),areai(iax,jax)
      real*8 cx1(iax),cx2(iax),cx3(iax),cx4(iax)
      real*8 cz1(jax),cz2(jax),cz3(jax),cz4(jax)
c
c ============================
c     inverse of mesh size
c ============================
c
      do i = 1,iax
         dxi(i) = 1.d0/dx(i)
         dxsi(i) = 1.d0/dxs(i)
      enddo
      do j = 1,jax
         dzi(j) = 1.d0/dz(j)
         dzsi(j) = 1.d0/dzs(j)
      enddo
c
c =================================
c     inverse of volume of mesh
c =================================
c
      do j = 1,jax
         do i = 1,iax
            areai(i,j) = dxi(i)*dzi(j)
         enddo
      enddo
c
c ===============
c     for fct
c ===============
c
      do  i = 3,iax-1
         cx1(i) = (xc(i)-xp(i-1))*(xc(i)-xp(i))*(xc(i)-xp(i+1))
     $        /(xp(i-2)-xp(i-1))/(xp(i-2)-xp(i))/(xp(i-2)-xp(i+1))
         cx2(i) = (xc(i)-xp(i-2))*(xc(i)-xp(i))*(xc(i)-xp(i+1))
     $        /(xp(i-1)-xp(i-2))/(xp(i-1)-xp(i))/(xp(i-1)-xp(i+1))
         cx3(i) = (xc(i)-xp(i-2))*(xc(i)-xp(i-1))*(xc(i)-xp(i+1))
     $        /(xp(i)-xp(i-2))/(xp(i)-xp(i-1))/(xp(i)-xp(i+1))
         cx4(i) = (xc(i)-xp(i-2))*(xc(i)-xp(i-1))*(xc(i)-xp(i))
     $        /(xp(i+1)-xp(i-2))/(xp(i+1)-xp(i-1))/(xp(i+1)-xp(i))
      enddo
c
      do j = 3,jax-1
         cz1(j) = (zc(j)-zp(j-1))*(zc(j)-zp(j))*(zc(j)-zp(j+1))
     $        /(zp(j-2)-zp(j-1))/(zp(j-2)-zp(j))/(zp(j-2)-zp(j+1))
         cz2(j) = (zc(j)-zp(j-2))*(zc(j)-zp(j))*(zc(j)-zp(j+1))
     $        /(zp(j-1)-zp(j-2))/(zp(j-1)-zp(j))/(zp(j-1)-zp(j+1))
         cz3(j) = (zc(j)-zp(j-2))*(zc(j)-zp(j-1))*(zc(j)-zp(j+1))
     $        /(zp(j)-zp(j-2))/(zp(j)-zp(j-1))/(zp(j)-zp(j+1))
         cz4(j) = (zc(j)-zp(j-2))*(zc(j)-zp(j-1))*(zc(j)-zp(j))
     $        /(zp(j+1)-zp(j-2))/(zp(j+1)-zp(j-1))/(zp(j+1)-zp(j))
      enddo
c
      return
      end
