      subroutine tstep(u,v,dx,dz,dxs,dzs,strs,eiv,dt,crmax,jstas,jends)
      use para4common
***********************************************************************
*     calculate time step
***********************************************************************
      implicit none
      include "meshnum"
c
      integer i,j
      real*8 dx(iax),dz(jax),dxs(iax),dzs(jax),dt
      real*8 dtd,dtd1,crmax
      real*8 u(iax,jax),v(iax,jax),dta,dta1,dtai
      real*8 strs(iax,jax),eiv(iax,jax)
      integer jstas(0:maxprocs-1),jends(0:maxprocs-1)
c
c --------------------------------------
c     courant condition of advection
c --------------------------------------
c
      dtai = 0.d0
c      do j = 2,jax-1
      do j = max(2,jstas(myrank)),min(jax-1,jends(myrank))
         do i = 2,iax-1
            dta1 = dabs(u(i,j))/dxs(i)
            dtai = dmax1(dtai,dta1)
         enddo
      enddo
c      do j = 3,jax-1
      do j = max(3,jstas(myrank)),min(jax-1,jends(myrank))
         do i = 2,iax-1
            dta1 = dabs(v(i,j))/dzs(j)
            dtai = dmax1(dtai,dta1)
         enddo
      enddo
      call mpi_allreduce(dtai,dta1,1,mpi_double_precision,mpi_max,
     $     mpi_comm_world,ierr)
      dta = 1.d0/dta1
c
c ---------------------------------------
c     courant condition for diffusion
c ---------------------------------------
c
      dtd1 = 1.d0
      do i = 2,iax-1
         dtd1 = dmin1(dtd1,dx(i))
      enddo
      do j = 2,jax-1
         dtd1 = dmin1(dtd1,dz(j))
      enddo
      dtd = 0.5d0*dtd1**2
c
      dt = crmax*dmin1(dta,dtd)
c      write(*,*)"dt =",dt
c
      return
      end
