      subroutine calvisc(tmp,zp,etl,epl,visc)
***********************************************************************
*     calculate viscosity from temperature and composition
*
*     input
*        tmp: temperature
*        etl: coefficient of temperature on viscosity
*        epl: coefficient of pressure on viscosity
*        zp: vertical coodinate
*     output
*        visc: viscosity
***********************************************************************
      implicit none
      include "meshnum"
c
      integer i,j
      real*8 tmp(iax,jax),etl,epl,visc(iax,jax),zp(jax)
      real*8 zz
c
      do j = 1,jax
         zz = 1.d0-zp(j)
         do  i = 1,iax
            visc(i,j) = exp(-etl*tmp(i,j)+epl*zz)
         enddo
      enddo
c
      return
      end
