      subroutine checkv(ntime,tmp,siv,eiv,dx,dz,asp)
***********************************************************************
*     print field values
***********************************************************************
      implicit none
      include "meshnum"
c
      integer ntime,i,j
      real*8 tmp(iax,jax),siv(iax,jax),eiv(iax,jax)
      real*8 dx(iax),dz(jax),asp,volume
      real*8 fsum,fmin,fmax,favg
c
      volume = asp
c
      write(24,'(i7,"-th timestep")')ntime
c
c     minimum/maximum/average temperature
c
      fsum = 0.d0
      fmin = 1.d5
      fmax = -1.d5
      do j = 2,jax-1
         do i = 2,iax-1
            fsum = fsum + tmp(i,j)*dx(i)*dz(j)
            fmax = dmax1(fmax,tmp(i,j))
            fmin = dmin1(fmin,tmp(i,j))
         enddo
      enddo
      favg = fsum/asp
      write(24,*)"average temperature =",favg
      write(24,*)"maximum temperature =",fmax
      write(24,*)"minimum temperature =",fmin
c
c     minimum/maximum/average stress
c
      fsum = 0.d0
      fmin = 1.d10
      fmax = -1.d5
      do j = 2,jax-1
         do i = 2,iax-1
            fsum = fsum + siv(i,j)*dx(i)*dz(j)
            fmax = dmax1(fmax,siv(i,j))
            fmin = dmin1(fmin,siv(i,j))
         enddo
      enddo
      favg = fsum/asp
      write(24,*)"average stress      =",favg
      write(24,*)"maximum stress      =",fmax
      write(24,*)"minimum stress      =",fmin
c
c     minimum/maximum/average strain rate
c
      fsum = 0.d0
      fmin = 1.d10
      fmax = -1.d5
      do j = 2,jax-1
         do i = 2,iax-1
            fsum = fsum + eiv(i,j)*dx(i)*dz(j)
            fmax = dmax1(fmax,eiv(i,j))
            fmin = dmin1(fmin,eiv(i,j))
         enddo
      enddo
      favg = fsum/asp
      write(24,*)"average strain rate =",favg
      write(24,*)"maximum strain rate =",fmax
      write(24,*)"minimum strain rate =",fmin
c
      return
      end
