      subroutine dfmesh(dx,dz,dxs,dzs,asp,xp,zp,xc,zc)
***********************************************************************
*     define mesh system
*
*          dxs(I)
*                dx(i)
*        |   |     |    |     |
*  J+1  -w---+-----w----+-----+-
*        |   |     |    |     |
*   j   -T---u-----T----u-----T- dz(j)
*        |   |     |    |     |
*   J   -w---+-----w----+-----+- dzs(J)
*        |   |     |    |     |
*  j-1  -T---u-----T----u-----T-
*        |   |     |    |     |
*
*            I     i   I+1   i+1
*
*     dxs(I) = (dx(i-1)+dx(i))/2
*     dzs(J) = (dz(j-1)+dz(j))/2
***********************************************************************
      implicit none
      include "meshnum"
c
      integer i,j
      real*8 dx(iax),dz(jax),dxs(iax),dzs(jax)
      real*8 xp(iax),zp(jax),xc(iax),zc(jax)
      real*8 dumx,dumz,asp
c
c =================
c     define dx
c =================
c
      dumx = asp/dble(nx)
      dx(2) = dumx
      do i = 3,iax-1
         dx(i) = dumx
      enddo
      dx(1)   = dx(2)
      dx(iax) = dx(iax-1)
c
c =================
c     define dz
c =================
c
      dumz = 1.d0/dble(nz)
      dz(2) = dumz
      do j = 3,jax-1
         dz(j) = dumz
      enddo
c
      dz(1)   = dz(2)
      dz(jax) = dz(jax-1)
c
c ==================
c     define dxs
c ==================
c
      do i = 2,iax
         dxs(i) = 0.5d0*(dx(i-1)+dx(i))
      enddo
      dxs(1) = dxs(2)
c
c ==================
c     define dzs
c ==================
c
      do j = 2,jax
         dzs(j) = 0.5d0*(dz(j-1)+dz(j))
      enddo
      dzs(1) = dzs(2)
c
c ----------------------------
c     set coodinate system
c ----------------------------
c
      zp(2) = 0.5d0*dz(2)
      zp(1) = zp(2)-dzs(2)
      do j = 3,jax
         zp(j) = zp(j-1)+dzs(j)
      enddo
      xp(2) = 0.5d0*dx(2)
      xp(1) = -dxs(2)
      do i = 3,iax
         xp(i) = xp(i-1)+dx(i)
      enddo
c
      xc(1) = -dx(1)
      xc(2) = 0.d0
      do i = 3,iax
         xc(i) = xc(i-1)+dx(i-1)
      enddo
      zc(1) = -dz(1)
      zc(2) = 0.d0
      do j = 3,jax
         zc(j) = zc(j-1)+dz(j-1)
      enddo
c
      return
      end
