      subroutine plot(iax,jax,asp,tmp,tsurf,tbot,qbot,
     $     dx,dz,u,w,eiv,siv,time,ntime)
***********************************************************************
*     plot average values
***********************************************************************
      implicit none
c
      integer i,j,iax,jax,nn,ij
      real*8 tmp(iax,jax),u(iax,jax),w(iax,jax)
      real*8 tsurf,tbot,dx(iax),dz(jax),asp,time,qbot
      real*8 vrms,vplt,tav,hfs,hfb
      real*8 sum,dum
      integer ntime
      real*8 siv(iax,jax),eiv(iax,jax)
      real*8 smax,emax
c
 1    format(a20," =",f18.10)
 2    format(2f10.4)
c
      sum = 0.d0
      do j = 2,jax-1
         do i = 2,iax-1
            sum = sum + tmp(i,j)*dx(i)*dz(j)
         enddo
      enddo
      tav = sum/asp
c
      sum = 0.d0
      do j = 2,jax-1
         do i = 2,iax-1
            sum = sum + 0.25d0*dx(i)*dz(j)*
     $           ((u(i,j)+u(i+1,j))**2+(w(i,j)+w(i,j+1))**2)
         enddo
      enddo
      vrms = dsqrt(sum/asp)
c
      sum = 0.d0
      do i = 2,iax-1
         sum = sum + 2.d0*(tmp(i,jax-1)-tsurf)*dx(i)/dz(jax-1)
c         sum = sum + tmp(i,jax-1)-tmp(i,jax)
      enddo
      hfs = sum/asp
c
      sum = 0.d0
      do i = 2,iax-1
         sum = sum + 2.d0*(tbot-tmp(i,2))*dx(i)/dz(2)
c         sum = sum + tmp(i,1)-tmp(i,2)
      enddo
      hfb = sum/asp
c      hfb = qbot
c
      smax = -10.d0
      do j = 2,jax-1
         do i = 2,iax-1
            smax = dmax1(siv(i,j),smax)
         enddo
      enddo
c
      emax = -10.d0
      do j = 2,jax-1
         do i = 2,iax-1
            emax = dmax1(eiv(i,j),emax)
         enddo
      enddo
c
c
      sum = 0.d0
      do i = 2,iax-1
         dum = 0.5d0*(u(i,j)+u(i+1,j))
         sum = sum + dum*dum*dx(i)
      enddo
      vplt = dsqrt(sum/asp)
c
      write(24,'(i6,a4,10a10)')ntime,"time","vrms","vplt","tav","hfs",
     $     "hfb","tbot","smax","emax"
      write(24,'(3e10.4,4f10.6,4e10.4)')time,vrms,vplt,tav,hfs,hfb,
     $     tbot,smax,emax
c
      write(20,'(11e11.4)')time,vrms,vplt,tav,hfs,hfb,tbot,
     $     smax,emax
c
      return
      end
