      subroutine rdata(nmax,nstep,iplot,iprnt,time,ivlt,icont,ivis,
     $     ipt,etl,etn,epl,epn,rat,tsurf,tbot,tamp,vboti,asp,ipf,
     $     relu,relw,relp,crmax)
***********************************************************************
*     read input parameters
***********************************************************************
      implicit none
      include "meshnum"
c
      integer nmax,iplot,iprnt,nstep
      integer ivlt,icont
      real*8 rat,tsurf,tbot,tamp,vboti,asp
      real*8 time
      integer ipt,ivis
      real*8 etl,etn,epl,epn
      real*8 depth,thex,grav,thdif,rhoref,rgas,tgap
      parameter(depth=6.5d5,thex=3.d-5,grav=9.8d0,
     $     thdif=6.d-7,rhoref=3.3d3,rgas=8.31d0)
      real*8 eta0,etas,etab,strs0
      real*8 dum
      character*80 ipf
      real*8 relu,relw,relp,crmax
c
      open(21,file=ipf)
      read(21,*) nmax,iplot,iprnt,icont
      read(21,*) rat,asp,ivlt
      read(21,*) ipt,etl,etn,epl,epn
      read(21,*) tsurf,tbot,tamp,vboti
      read(21,*) nstep,time
      read(21,*) relu,relw,relp,crmax
      close(21)
c
c     show some parameters in real dimensions
c
c      if (icont .eq. 0) then
c         tgap = tbot -tsurf
c      else
c         tgap = tamp
c      endif
      tgap = 1.3d3
      eta0 = rhoref*thex*tgap*grav*depth**3/thdif/rat
      strs0 = eta0*thdif/depth/depth*1.d-6
      if (ipt .eq. 0) then
         etas = 1.d0
         etab = 1.d0
      else if (ipt .eq. 1) then
         etas = exp(etl/tsurf)
         etab = exp((etl+epl)/tbot)
      else if (ipt .eq. 2) then
         etas = exp(-etl*tsurf)
         etab = exp(-etl*tbot+epl)
      endif
c
      write(24,'(4a10)') "nmax","iplot","iprnt","icont"
      write(24,'(4i10)') nmax,iplot,iprnt,icont
      write(24,'(3a10)')"Nx","Nz","asp"
      write(24,'(2i10,f10.4)')nx,nz,asp
      write(24,'(4a10)') "RaT","ivlt","ipt"
      write(24,'(e10.4,3i10)') rat,ivlt,ipt
      write(24,'(7a10)')"eta0","etas","etab","etl","etn","epl","epn"
      write(24,'(7e10.4)')eta0,etas,etab,etl,etn,epl,epn
      write(24,'(4a10)') "tsurf","tbot","tamp","vbot^(-1)"
      write(24,'(4f10.4)') tsurf,tbot,tamp,vboti
      write(24,'(a10)') "time"
      write(24,'(e10.4)') time
      write(24,'(4a10)')"relu","relw","relp","crmax"
      write(24,'(4f10.4)')relu,relw,relp,crmax
c
      if (ivlt .eq. 1) then
         write(24,*)"free-slip top boundary"
      else if (ivlt .eq. 2) then
         write(24,*)"fixed velocity top boundary"
      endif
      if (ipt .eq. 1) then
c     $     write(24,*)"Arhenius-law dependence"
         write(24,*)"DO NOT USE ipt=1"
         stop
      endif
      if (ipt .eq. 2) write(24,*)"simplified P/T dependence"
      if (ipt .ge. 3) then
         write(24,'("Illegal value of ipt =",i2)')ipt
         stop
      endif
c
c      dum = epn*epn+etn*etn
c      if (dum .gt. 1.d-20) then
c         ivis = 1
c         write(24,*)"Nonlinear rheology"
c      else
         ivis = 0
         write(24,*)"Linear rheology"
c      endif
c
      return
      end
