      subroutine tstep(u,v,dx,dz,dxs,dzs,strs,eiv,dt,crmax)
***********************************************************************
*     calculate time step
***********************************************************************
      implicit none
      include "meshnum"
c
      integer i,j
      real*8 dx(iax),dz(jax),dxs(iax),dzs(jax),dt
      real*8 dtd,dtd1,crmax
      real*8 u(iax,jax),v(iax,jax),dta,dta1,dtai
      real*8 strs(iax,jax),eiv(iax,jax)
c
c --------------------------------------
c     courant condition of advection
c --------------------------------------
c
      dtai = 0.d0
      do 12 j = 2,jax-1
         do 11 i = 2,iax-1
            dta1 = dabs(u(i,j))/dxs(i)
            dtai = dmax1(dtai,dta1)
 11      continue
 12   continue
      do 22 j = 3,jax-1
         do 21 i = 2,iax-1
            dta1 = dabs(v(i,j))/dzs(j)
            dtai = dmax1(dtai,dta1)
 21      continue
 22   continue
      dta = 1.d0/dtai
c
c ---------------------------------------
c     courant condition for diffusion
c ---------------------------------------
c
      dtd1 = 1.d0
      do i = 2,iax-1
         dtd1 = dmin1(dtd1,dx(i))
      enddo
      do j = 2,jax-1
         dtd1 = dmin1(dtd1,dz(j))
      enddo
      dtd = 0.5d0*dtd1**2
c
      dt = crmax*dmin1(dta,dtd)
c      write(*,*)"dt =",dt
c
      return
      end
