      program gtall
***********************************************************************
*     convert data files for drawing
***********************************************************************
      implicit none
      include "../src/meshnum"
c
      integer i,j,n,num,nplt
      integer ntime
      real*8 time,ra
      real*8 asp,xp(iax),zp(jax),xc(iax),zc(jax)
      real*8 dx(iax),dz(jax),dxs(iax),dzs(jax)
      real*8 tmp(iax,jax),u(iax,jax),w(iax,jax),sch(iax,jax),
     $     siv(iax,jax),eiv(iax,jax),visc(iax,jax)
      real*8 pi,rad,dum
      real*8 time0,depth,thdif,secy
      parameter(depth=6.5d5,thdif=6.d-7,secy=3.65d2*8.64d4)
      parameter(time0=depth*depth/thdif/secy)
      integer icode(0:9)
c
      integer ns,ne,n1,n2,n3
      character*10 fout
      character*1 cn1,cn2,cn3
      character*3 cn
c
      data icode /48,49,50,51,52,53,54,55,56,57/
c
      pi = 4.d0*datan(1.d0)
      rad = 1.8d2/pi
c
      open(21,file="inparam000")
      read(21,*)num,nplt
      read(21,*)ra,asp
      close(21)
c
c --------------------------------
c     define coordinate system
c --------------------------------
c
      call dfmesh(dx,dz,dxs,dzs,asp,xp,zp,xc,zc)
c
 1    format(8e11.4)
 2    format(2f8.5,f10.4)
 3    format(2f8.5,e12.4)
 100  continue
      read(*,*,end=99)ntime,time
      read(*,1,end=99)tmp,u,w,sch,siv,eiv,visc
c
c ---------------------------------
c     apply boundary conditions
c ---------------------------------
c
      do i = 1,iax
         siv(i,1)   = siv(i,2)
         siv(i,jax) = siv(i,jax-1)
      enddo
      do j = 1,jax
         siv(1,j)   = siv(2,j)
         siv(iax,j) = siv(iax-1,j)
      enddo
      do i = 1,iax
         eiv(i,1)   = eiv(i,2)
         eiv(i,jax) = eiv(i,jax-1)
      enddo
      do j = 1,jax
         eiv(1,j)   = eiv(2,j)
         eiv(iax,j) = eiv(iax-1,j)
      enddo
      do i = 1,iax
         visc(i,1)   = visc(i,2)
         visc(i,jax) = visc(i,jax-1)
      enddo
      do j = 1,jax
         visc(1,j)   = visc(2,j)
         visc(iax,j) = visc(iax-1,j)
      enddo
c
c     define file names
c
      ns = ntime/nplt
      if (ns .lt. 10) then
         n1 = ns
         cn1 = char(icode(n1))
         cn = "00"//cn1
      else if (ns .lt. 100) then
         n1 = mod(ns,10)
         n2 = ns/10
         cn1 = char(icode(n1))
         cn2 = char(icode(n2))
         cn = "0"//cn2//cn1
      else
         n1 = mod(ns,10)
         n3 = ns/100
         n2 = (ns-n3*100-n1)/10
         cn1 = char(icode(n1))
         cn2 = char(icode(n2))
         cn3 = char(icode(n3))
         cn = cn3//cn2//cn1
      endif
      write(*,*)cn,ntime,time,"(",time*time0*1.d-6,"[My])"
c
      fout = "tmp"//cn//".dat"
      open(51,file=fout)
      do j = 2,jax
         do i = 2,iax
            dum = 0.25d0*(
     $           tmp(i-1,j-1)*dx(i)*dz(j)
     $           +tmp(i,j-1)*dx(i-1)*dz(j)
     $           +tmp(i-1,j)*dx(i)*dz(j-1)
     $           +tmp(i,j)*dx(i-1)*dz(j-1)
     $           )/dxs(i)/dzs(j)
            write(51,2)xc(i),zc(j),dum
         enddo
      enddo
      close(51)
c
c      fout = "psi"//cn//".dat"
c      open(51,file=fout)
c      do j = 2,jax
c         do i = 2,iax
c            dum = psi(i,j)
c            write(51,3)xc(i),zc(j),dum
c         enddo
c      enddo
c      close(51)
c
      fout = "siv"//cn//".dat"
      open(51,file=fout)
      do j = 2,jax
         do i = 2,iax
            dum = 0.25d0*(
     $           siv(i-1,j-1)*dx(i)*dz(j)
     $           +siv(i,j-1)*dx(i-1)*dz(j)
     $           +siv(i-1,j)*dx(i)*dz(j-1)
     $           +siv(i,j)*dx(i-1)*dz(j-1)
     $           )/dxs(i)/dzs(j)
            write(51,2)xc(i),zc(j),dlog10(dum)
         enddo
      enddo
      close(51)
c
      fout = "eiv"//cn//".dat"
      open(51,file=fout)
      do j = 2,jax
         do i = 2,iax
            dum = 0.25d0*(
     $           eiv(i-1,j-1)*dx(i)*dz(j)
     $           +eiv(i,j-1)*dx(i-1)*dz(j)
     $           +eiv(i-1,j)*dx(i)*dz(j-1)
     $           +eiv(i,j)*dx(i-1)*dz(j-1)
     $           )/dxs(i)/dzs(j)
            write(51,2)xc(i),zc(j),dlog10(dum)
         enddo
      enddo
      close(51)
c
      fout = "vis"//cn//".dat"
      open(51,file=fout)
      do j = 2,jax
         do i = 2,iax
            dum = 0.25d0*(
     $           visc(i-1,j-1)*dx(i)*dz(j)
     $           +visc(i,j-1)*dx(i-1)*dz(j)
     $           +visc(i-1,j)*dx(i)*dz(j-1)
     $           +visc(i,j)*dx(i-1)*dz(j-1)
     $           )/dxs(i)/dzs(j)
            write(51,2)xc(i),zc(j),dlog10(dum)
         enddo
      enddo
      close(51)
c
      fout = "vlx"//cn//".dat"
      open(51,file=fout)
      do j = 2,jax-1
         do i = 2,iax
            write(51,3)xc(i),zp(j),u(i,j)
         enddo
      enddo
      close(51)
c
      fout = "vlz"//cn//".dat"
      open(51,file=fout)
      do j = 2,jax
         do i = 2,iax-1
            write(51,3)xp(i),zc(j),w(i,j)
         enddo
      enddo
      close(51)
c
      goto 100
c
 99   continue
c
      stop
      end
