#!/bin/csh -f
# write(20,'(11e11.4)')time,vrms,vplt,tav,hfs,hfb,tbot,
#     smax,emax,psimax

set data = ./$$.data
set bindir = ../utils/

if ($#argv != 0) then
  set file = ( $argv[1-$#argv] )
else
  set file = ( 20*dat* )
endif

# filter
if (-f .skip20) then
  set filter = $bindir/skip20
else
  set filter = cat
endif

# convert 20*.dat
touch $data
foreach f ( $file[*] )
    switch ($f)
	case *.Z:
	    zcat $f | $filter >> $data
	    breaksw
	case *.gz:
	    gzip -dc $f | $filter >> $data
	    breaksw
	case *.bz2:
	    bzip2 -dc $f | $filter >> $data
	    breaksw
	default:
	    cat $f | $filter >> $data
	    breaksw
    endsw
end
$bindir/pltdata < $data

rm -f $data
if ($?DISPLAY) then
  gnuplot ${bindir}/draw
  rm -f t_bot.dat  t_hfb.dat  t_plt.dat  t_rms.dat  t_tav.dat t_emx.dat  t_hfs.dat  t_psi.dat  t_smx.dat
endif
